#include <iostream>
#include <cmath>

#define e 2.718281828459
#define f(x) (1 + 2*(x))/pow(log(2 + (x)*(x)),2)
#define f_prime(x) (-4*x*log(2 + x*x)/pow(log(2 + x*x),3) + 2/pow(log(2 + x*x),2))
#define f_second_derivative(x) (-(12*x*x + 4)*log(2 + x*x)/pow(log(2 + x*x),4) + (12*x)/pow(log(2 + x*x),3) - (4*x)/pow(log(2 + x*x),2))
#define f_fourth_derivative(x) (-(4*(15*x*x*x*x + 60*x*x + 12))*log(2 + x*x)/pow(log(2 + x*x),6) + (240*x*x*x + 720*x)/pow(log(2 + x*x),5) - (216*x*x + 720)/pow(log(2 + x*x),4))
#define calch float h = (b - a) / n

float Rectangle(float a, float b, int n, char right) {//right має приймати значення 0 для лівих, 1 для правих і 2 для середніх
    float sum = 0;
    calch;
    std::cout<<h<<"*(";
    for (int i = right%2; i < n+right%2; i++) {
        float x = a + (i + right/2/2.0)* h;
        sum += f(x);
        std::cout<<f(x);
        if(i+1!=n+right%2)std::cout<<'+';
    }
    std::cout<<")"<<
#ifdef OFFICE_OUTPUT
        "newline"<<
#endif
        std::endl;
    return sum * h;
}

float trapezoidal(float a, float b, int n) {
    float sum = 0;
    calch;
    std::cout<<h<<"*(";
    sum += (f(a) + f(b))/2;
    std::cout<<f(a)<<"/2+"<<f(b)<<"/2+";
    for (int i = 1; i < n; i++) {
        float x = a + i * h;
        sum += f(x);
        std::cout<<f(x);
        if(i+1!=n)std::cout<<'+';
    }
    std::cout<<")"<<
#ifdef OFFICE_OUTPUT
        "newline"<<
#endif
        std::endl;
    return sum * h;
}

float simpson(float a, float b, int n) {
    if (n%2) n++;
    float sum = f(a) + f(b);
    calch;
    std::cout<<h/3<<"*("<<f(a)<<'+'<<f(b)<<"+4*(";
    for (int i = 1; i < n; i += 2) {
        float x = a + i * h;
        sum += 4 * f(x);
        std::cout<<f(x);
        if(i+1!=n)std::cout<<'+';
    }
    std::cout<<")+2*(";
    for (int i = 2; i < n; i += 2) {
        float x = a + i * h;
        sum += 2 * f(x);
        std::cout<<f(x);
        if(i+2!=n)std::cout<<'+';
    }
    std::cout<<')'<<
#ifdef OFFICE_OUTPUT
        "newline"<<
#endif
        std::endl;
    return sum * h / 3;
}

void calculateError(float a, float b, int n, float *error1, float *error2, float *error4) {
    calch;
    float max_f_prime = 0;
    float max_f_second = 0;
    float max_f_fourth = 0;
    
    for (int i = 0; i <= n; i++) {
        float x = a + i * h;
        float f_prime_val = fabs(f_prime(x));
        float f_second_val = fabs(f_second_derivative(x));
        float f_fourth_val = fabs(f_fourth_derivative(x));
        
        if (!isinf(f_prime_val) && !isnan(f_prime_val) && f_prime_val > max_f_prime) max_f_prime = f_prime_val;
        if (!isinf(f_second_val) && !isnan(f_second_val) && f_second_val > max_f_second) max_f_second = f_second_val;
        if (!isinf(f_fourth_val) && !isnan(f_fourth_val) && f_fourth_val > max_f_fourth) max_f_fourth = f_fourth_val;
    }
    
    *error1 = (b - a) * h / 2 * max_f_prime;
    *error2 = (b - a) * h * h / 24 * max_f_second;
    *error4 = (b - a) * pow(h,4) / 180 * max_f_fourth;
    
    std::cout<<"Максимальна похідна першого порядку: "<<max_f_prime<<std::endl;
    std::cout<<"Максимальна похідна другого порядку: "<<max_f_second<<std::endl;
    std::cout<<"Максимальна похідна четвертого порядку: "<<max_f_fourth<<std::endl;
}

int main() {
    float a = 0;
    float b = 4;
    unsigned short n = 150;
    
    std::cout<<
#ifdef OFFICE_OUTPUT
              "I_l="
#else
        "Il="
#endif
    ;float leftResult = Rectangle(a, b, n, 0);
    std::cout<<
#ifdef OFFICE_OUTPUT
    "I_r="
#else
    "Ir="
#endif
    ;float rightResult = Rectangle(a, b, n, 1);
    std::cout<<
#ifdef OFFICE_OUTPUT
    "I_m="
#else
    "Im="
#endif
    ;float middleResult = Rectangle(a, b, n, 2);
    std::cout<<
#ifdef OFFICE_OUTPUT
        "I_t="
#else
        "It="
#endif
        ;float trapezoidalResult = trapezoidal(a, b, n);
    std::cout<<
#ifdef OFFICE_OUTPUT
        "I_s="
#else
        "Is="
#endif
        ;float simpsonResult = simpson(a, b, n);
    
    float error1, error2, error4;
    calculateError(a, b, n, &error1, &error2, &error4);
    float x=a;
    unsigned short i=0;
    while (x<(b-b/n)){
        i++;
        x+=fabs(b-a)/n;
        std::cout<<'x'
#ifdef OFFICE_OUTPUT
            <<'_'
#endif
                  <<i<<'='<<x<<"\t f(x"
#ifdef OFFICE_OUTPUT
                  <<'_'
#endif
                  <<i<<")="<<f(x)
#ifdef OFFICE_OUTPUT
            ; if(i!=n)std::cout<<"newline";std::cout
#endif
                  <<std::endl;
    }
    
    std::cout<<"Метод лівих прямокутників: "<<leftResult<<", Похибка: R<="<<error1<<std::endl;
    std::cout<<"Метод правих прямокутників: "<<rightResult<<", Похибка: R<="<<error1<<std::endl;
    std::cout<<"Метод середніх прямокутників: "<<middleResult<<", Похибка: R<="<<error2<<std::endl;
    std::cout<<"Метод трапецій: "<<trapezoidalResult<<", Похибка: R<="<<error2<<std::endl;
    std::cout<<"Метод Сімпсона: "<<simpsonResult<<", Похибка: R<="<<error4<<std::endl;
    
    return 0;
}
